/*
 * dataLoader.java
 *
 * Created on July 26, 2000, 1:08 PM
 */

/**
 *
 * @author  furyhawk
 * @version 0.01
 */

/**
 ********************************************************************
CivLog - Copyright (C) 2000 - Wong Teck Meng
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 **********************************************************************
 */

import java.util.*;
import java.io.*;
import java.io.File;

//import java.awt.*;
//import java.awt.event.*;

import javax.swing.*;

public class CivLogData extends Object {

  /** I still confused where to use static */
  /** to be change to the newer jdk-1.2 Arraylist in future */
  public static Vector civscore = new Vector ();
  public static Vector playerNames = new Vector ();

  /** Records num of player, start year, end year, scale factors */
  /** TODO: What if two files are loaded? (one after another) */
  public static int numofPlayers  = 0;
  public static int startYear     = -4000;
  public static int endYear       = 2000;
  public static int currentPlayer = 0;

  /** maximum */
  /** scale factor for individual player is possible, vectorized it */
  public static int maxPop          = 0;
  public static int maxBnp          = 0;
  public static int maxMfg          = 0;
  public static int maxCities       = 0;
  public static int maxTechs        = 0;
  public static int maxMunits       = 0;
  public static int maxSettlers     = 0;
  public static int maxWonders      = 0;
  public static int maxTechout      = 0;
  public static long maxLandArea    = 0;
  public static long maxSettledArea = 0;
  public static int maxPollution    = 0;
  public static int maxLiteracy     = 0;
  public static int maxSpaceship    = 0;


  /** JFrame for Message Dialog */
  static JFrame frame;


  /** Creates new CivLogData */
  public CivLogData (JFrame pframe) {
    /** is super automatically called if not included */
    super ();
    /** default */
    int numofPlayers = 0;
    int startYear    = -4000;
    int endYear      = 2000;
    /** assign parent frame */
    frame = pframe;
  }

  /** don't be fool by the get, it set data also */
  static CivLogDataEntry get_entry (int year, int player) {
    for (int i=0; i < civscore.size (); i++) {
      CivLogDataEntry current = (CivLogDataEntry)civscore.elementAt (i);
      /** because something then go */
      if ( (current.year==year) && (current.player==player))
      return current;
    }
    /** nothing found -> create new one */
    CivLogDataEntry newOne = new CivLogDataEntry (year, player);
    civscore.addElement (newOne);
    return newOne;
  }

  /** why does it had to be static to be called from frmCivlog.jmiOpenActionPerformed? */
  /** assuming that old data is clear if load fail. put numofPlayers before every return() */
  /** to be perfect?? */
  /** return load success or failure */
  public static boolean dataLoader (File theFile, String filePath) {

    try {
      BufferedReader in = new BufferedReader (new FileReader (theFile));
      String line;

      line = in.readLine ();

      if (line != null) {
        if (line.startsWith ("#FREECIV SCORELOG")) {
          /** TODO: button change to loadme */
          //JOptionPane.showMessageDialog (frame,
          //"It is a Civlog File: " + filePath
          //+ "\nLoading.....Wait even after pressing OK"
          //);
        }
        else {
          JOptionPane.showMessageDialog (frame,
          "Not a Civlog File: " + filePath,
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          /** quit if no a civlog file */
          return (false);
        }
      }

      /** read in the secondline to start the ball rolling */
      //line = in.readLine ();

      /** FIXME: add more checks */
      /** check for header and get rid to it */
      for (;;) {
        line = in.readLine ();
        if (line == null) {
          JOptionPane.showMessageDialog (frame,
          "Error while data header is readed",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          return (false);
        }
        StringTokenizer st = new StringTokenizer (line);
        if (st.countTokens () > 2) {
          /** shouldn't be */
          JOptionPane.showMessageDialog (frame,
          "Error while data header is readed II",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          return (false);
        }
        /** get rid of first token */
        String abc = st.nextToken ();
        if ( abc.equalsIgnoreCase ("end") ) {
          /** every OK! goto next parse*/
          break;
        }
        /** this part is reductant at the moment */
        abc = st.nextToken ();
        /** maybe the following if() can be done more professionally */
        if ( ! (abc.equalsIgnoreCase ("pop") || abc.equalsIgnoreCase ("bnp")
        || abc.equalsIgnoreCase ("mfg") || abc.equalsIgnoreCase ("cities")
        || abc.equalsIgnoreCase ("techs") || abc.equalsIgnoreCase ("munits")
        || abc.equalsIgnoreCase ("settlers") || abc.equalsIgnoreCase ("wonders")
        || abc.equalsIgnoreCase ("techout") || abc.equalsIgnoreCase ("landarea")
        || abc.equalsIgnoreCase ("settledarea") || abc.equalsIgnoreCase ("pollution")
        || abc.equalsIgnoreCase ("literacy") || abc.equalsIgnoreCase ("spaceship")
        ) ) {
          JOptionPane.showMessageDialog (frame,
          "Error while data header is readed III",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          return (false);
        }
      }

      /** clear everythings before reading in new data */
      /** I suppose .clear() clean the internal data also? */
      civscore.clear ();
      playerNames.clear ();
      /** reset value, use by paint function to flag whether the data is loaded */
      numofPlayers = 0;
      /** read in the lines and get no. of players */
      for (;;) {
        line = in.readLine ();
        if (line == null) {
          JOptionPane.showMessageDialog (frame,
          "Error while players header is readed",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          return (false);
        }
        /** check for end of players header */
        if (line.startsWith ("end")) {
          /** everything OK! goto next parse */
          break;
        }
        /** is it OK to allocate string here */
        int index;
        index = line.indexOf (" ");
        /** extract player names */
        String player = new String (line.substring (index));
        playerNames.addElement (player);
        /** no. of players */
        numofPlayers++;
      }

      /* initial condition */
      boolean checkStartYear = false;

      /** FIXME: add more checks and optimize*/
      for (;;) {
        line = in.readLine ();
        if (line == null) {
          /** finished */
          break;
        }

        /** can this part be optimized?  It is allocating too much memory? */
        StringTokenizer st = new StringTokenizer (line);

        /** where will it go if throwed, out of for() or ??? */
        if (st.countTokens () < 4)
        throw new RuntimeException ("Not enough fields");

        String typeStr   = st.nextToken ();
        String playerStr = st.nextToken ();
        String yearStr   = st.nextToken ();
        String valueStr  = st.nextToken ();

        int type, player, year;
        long value; /** area value range can be very big */

        try {
          type   = Integer.parseInt (typeStr);
          player = Integer.parseInt (playerStr);
          year   = Integer.parseInt (yearStr);
          value  = Long.parseLong   (valueStr);
        }
        /** where will it go if throwed, out of for() or ??? */
        catch (NumberFormatException nfe) {
          throw new RuntimeException ("Illegal line " + line + nfe);
        }

       switch (type) {
          case Freeciv.POP:         maxPop         = Math.max (maxPop, (int)value);
                                    break;
          case Freeciv.BNP:         maxBnp         = Math.max (maxBnp, (int)value);
                                    break;
          case Freeciv.MFG:         maxMfg         = Math.max (maxMfg, (int)value);
                                    break;
          case Freeciv.CITIES:      maxCities      = Math.max (maxCities, (int)value);
                                    break;
          case Freeciv.TECHS:       maxTechs       = Math.max (maxTechs, (int)value);
                                    break;
          case Freeciv.MUNITS:      maxMunits      = Math.max (maxMunits, (int)value);
                                    break;
          case Freeciv.SETTLERS:    maxSettlers    = Math.max (maxSettlers, (int)value);
                                    break;
          case Freeciv.WONDERS:     maxWonders     = Math.max (maxWonders, (int)value);
                                    break;
          case Freeciv.TECHOUT:     maxTechout     = Math.max (maxTechout, (int)value);
                                    break;
          case Freeciv.LANDAREA:    maxLandArea    = Math.max (maxLandArea, value);
                                    break;
          case Freeciv.SETTLEDAREA: maxSettledArea = Math.max (maxSettledArea, value);
                                    break;
          case Freeciv.POLLUTION:   maxPollution   = Math.max (maxPollution, (int)value);
                                    break;
          case Freeciv.LITERACY:    maxLiteracy    = Math.max (maxLiteracy, (int)value);
                                    break;
          case Freeciv.SPACESHIP:   maxSpaceship   = Math.max (maxSpaceship, (int)value);
                                    break;
          default:           JOptionPane.showMessageDialog (frame,
                             "Error while type header is been readed",
                             "Error",
                             JOptionPane.ERROR_MESSAGE
                             );
                             return (false);
        }
      
      if (!checkStartYear) {
        startYear = year;
        checkStartYear = true;
      }

      endYear = year;
      /** I supposed clde is deleted once out of for() */
      CivLogDataEntry clde = get_entry (year, player);
      clde.set_data (type, (int)value);
      //System.out.println("\nValue: " + value); /* don't do it, it slowwww */
    }

    /** to exec this section, the previous ops should be OK! or else... */
    in.close ();

    JOptionPane.showMessageDialog (frame,
    "No. of players: " + numofPlayers
    + "\nStart Year: " + startYear
    + "\nEnd Year: " + endYear
    );

    /** initialise the sliders values */
    //frame.jsldrStartYear.setMinimum(startYear);
    //frame.jsldrEndYear.setMaximum(endYear);
    //frame.jsldrStartYear.setValue(CivLogData.startYear);
    //frame.jsldrEndYear.setValue(CivLogData.endYear);

  } catch (IOException e) {
    /** FIXME: Add more debugging features */
  }
  return (true);
}

}